VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLCDPanel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event ButtonReleased(ButtonReleased As ButtonType)

Private WithEvents Panel As MSComm
Attribute Panel.VB_VarHelpID = -1
Private WithEvents PanelTimer As Timer
Attribute PanelTimer.VB_VarHelpID = -1


Private PanelLine(1) As String
Private ScrollPos1 As Integer
Private ScrollPos2 As Integer
Private ScrollDir1 As Integer
Private ScrollDir2 As Integer

Public Enum ButtonType
    UpButton
    RightButton
    DownButton
    LeftButton
    EnterButton
    CancelButton
End Enum

Public Enum Speed
    Slower
    Slow
    Medium
    Fast
    Faster
End Enum


Private Type WORD
   Lo As Byte
   Hi As Byte
End Type

Private Type PACKET_STRUCT
   command As Byte
   data_length As Byte
   data(22) As Byte
   crc As WORD
End Type


Dim crcLookupTable(256) As WORD

Public Property Set MsCommControl(Value As MSComm)
    Set Panel = Value
    
    If (Panel.PortOpen = False) Then
        
        Panel.PortOpen = True
    
    Else
        Err.Raise 101, "clsLCDPanel", "Port already open."
    End If
    
End Property
Public Property Set ScrollTimer(Value As Timer)
    Set PanelTimer = Value
    PanelTimer.Enabled = False
End Property

Public Property Let ScrollSpeed(Value As Speed)
    Select Case Value
        Case Speed.Slower
            PanelTimer.Interval = 1500
        Case Speed.Slow
            PanelTimer.Interval = 1000
        Case Speed.Medium
            PanelTimer.Interval = 750
        Case Speed.Fast
            PanelTimer.Interval = 500
        Case Speed.Faster
            PanelTimer.Interval = 200
    
    End Select
End Property


Public Sub Display(LineOne As String, LineTwo As String, Scroll As Boolean)
    PanelLine(0) = LineOne
    PanelLine(1) = LineTwo
    
    If Scroll = False Then
        PanelTimer.Enabled = False
        SendLines PanelLine(0), PanelLine(1)
    Else
        ScrollPos1 = 1
        ScrollPos2 = 1
        ScrollDir1 = 0
        ScrollDir2 = 0
        PanelTimer.Enabled = True
    End If
    
End Sub



Private Sub Class_Terminate()
    On Error Resume Next
    Panel.PortOpen = False
End Sub

Private Sub Initialize_CRC_Lookup_Table()
  crcLookupTable(0).Lo = &H0
  crcLookupTable(0).Hi = &H0
  crcLookupTable(1).Lo = &H89
  crcLookupTable(1).Hi = &H11
  crcLookupTable(2).Lo = &H12
  crcLookupTable(2).Hi = &H23
  crcLookupTable(3).Lo = &H9B
  crcLookupTable(3).Hi = &H32
  crcLookupTable(4).Lo = &H24
  crcLookupTable(4).Hi = &H46
  crcLookupTable(5).Lo = &HAD
  crcLookupTable(5).Hi = &H57
  crcLookupTable(6).Lo = &H36
  crcLookupTable(6).Hi = &H65
  crcLookupTable(7).Lo = &HBF
  crcLookupTable(7).Hi = &H74
  crcLookupTable(8).Lo = &H48
  crcLookupTable(8).Hi = &H8C
  crcLookupTable(9).Lo = &HC1
  crcLookupTable(9).Hi = &H9D
  crcLookupTable(10).Lo = &H5A
  crcLookupTable(10).Hi = &HAF
  crcLookupTable(11).Lo = &HD3
  crcLookupTable(11).Hi = &HBE
  crcLookupTable(12).Lo = &H6C
  crcLookupTable(12).Hi = &HCA
  crcLookupTable(13).Lo = &HE5
  crcLookupTable(13).Hi = &HDB
  crcLookupTable(14).Lo = &H7E
  crcLookupTable(14).Hi = &HE9
  crcLookupTable(15).Lo = &HF7
  crcLookupTable(15).Hi = &HF8
  crcLookupTable(16).Lo = &H81
  crcLookupTable(16).Hi = &H10
  crcLookupTable(17).Lo = &H8
  crcLookupTable(17).Hi = &H1
  crcLookupTable(18).Lo = &H93
  crcLookupTable(18).Hi = &H33
  crcLookupTable(19).Lo = &H1A
  crcLookupTable(19).Hi = &H22
  crcLookupTable(20).Lo = &HA5
  crcLookupTable(20).Hi = &H56
  crcLookupTable(21).Lo = &H2C
  crcLookupTable(21).Hi = &H47
  crcLookupTable(22).Lo = &HB7
  crcLookupTable(22).Hi = &H75
  crcLookupTable(23).Lo = &H3E
  crcLookupTable(23).Hi = &H64
  crcLookupTable(24).Lo = &HC9
  crcLookupTable(24).Hi = &H9C
  crcLookupTable(25).Lo = &H40
  crcLookupTable(25).Hi = &H8D
  crcLookupTable(26).Lo = &HDB
  crcLookupTable(26).Hi = &HBF
  crcLookupTable(27).Lo = &H52
  crcLookupTable(27).Hi = &HAE
  crcLookupTable(28).Lo = &HED
  crcLookupTable(28).Hi = &HDA
  crcLookupTable(29).Lo = &H64
  crcLookupTable(29).Hi = &HCB
  crcLookupTable(30).Lo = &HFF
  crcLookupTable(30).Hi = &HF9
  crcLookupTable(31).Lo = &H76
  crcLookupTable(31).Hi = &HE8
  crcLookupTable(32).Lo = &H2
  crcLookupTable(32).Hi = &H21
  crcLookupTable(33).Lo = &H8B
  crcLookupTable(33).Hi = &H30
  crcLookupTable(34).Lo = &H10
  crcLookupTable(34).Hi = &H2
  crcLookupTable(35).Lo = &H99
  crcLookupTable(35).Hi = &H13
  crcLookupTable(36).Lo = &H26
  crcLookupTable(36).Hi = &H67
  crcLookupTable(37).Lo = &HAF
  crcLookupTable(37).Hi = &H76
  crcLookupTable(38).Lo = &H34
  crcLookupTable(38).Hi = &H44
  crcLookupTable(39).Lo = &HBD
  crcLookupTable(39).Hi = &H55
  crcLookupTable(40).Lo = &H4A
  crcLookupTable(40).Hi = &HAD
  crcLookupTable(41).Lo = &HC3
  crcLookupTable(41).Hi = &HBC
  crcLookupTable(42).Lo = &H58
  crcLookupTable(42).Hi = &H8E
  crcLookupTable(43).Lo = &HD1
  crcLookupTable(43).Hi = &H9F
  crcLookupTable(44).Lo = &H6E
  crcLookupTable(44).Hi = &HEB
  crcLookupTable(45).Lo = &HE7
  crcLookupTable(45).Hi = &HFA
  crcLookupTable(46).Lo = &H7C
  crcLookupTable(46).Hi = &HC8
  crcLookupTable(47).Lo = &HF5
  crcLookupTable(47).Hi = &HD9
  crcLookupTable(48).Lo = &H83
  crcLookupTable(48).Hi = &H31
  crcLookupTable(49).Lo = &HA
  crcLookupTable(49).Hi = &H20
  crcLookupTable(50).Lo = &H91
  crcLookupTable(50).Hi = &H12
  crcLookupTable(51).Lo = &H18
  crcLookupTable(51).Hi = &H3
  crcLookupTable(52).Lo = &HA7
  crcLookupTable(52).Hi = &H77
  crcLookupTable(53).Lo = &H2E
  crcLookupTable(53).Hi = &H66
  crcLookupTable(54).Lo = &HB5
  crcLookupTable(54).Hi = &H54
  crcLookupTable(55).Lo = &H3C
  crcLookupTable(55).Hi = &H45
  crcLookupTable(56).Lo = &HCB
  crcLookupTable(56).Hi = &HBD
  crcLookupTable(57).Lo = &H42
  crcLookupTable(57).Hi = &HAC
  crcLookupTable(58).Lo = &HD9
  crcLookupTable(58).Hi = &H9E
  crcLookupTable(59).Lo = &H50
  crcLookupTable(59).Hi = &H8F
  crcLookupTable(60).Lo = &HEF
  crcLookupTable(60).Hi = &HFB
  crcLookupTable(61).Lo = &H66
  crcLookupTable(61).Hi = &HEA
  crcLookupTable(62).Lo = &HFD
  crcLookupTable(62).Hi = &HD8
  crcLookupTable(63).Lo = &H74
  crcLookupTable(63).Hi = &HC9
  crcLookupTable(64).Lo = &H4
  crcLookupTable(64).Hi = &H42
  crcLookupTable(65).Lo = &H8D
  crcLookupTable(65).Hi = &H53
  crcLookupTable(66).Lo = &H16
  crcLookupTable(66).Hi = &H61
  crcLookupTable(67).Lo = &H9F
  crcLookupTable(67).Hi = &H70
  crcLookupTable(68).Lo = &H20
  crcLookupTable(68).Hi = &H4
  crcLookupTable(69).Lo = &HA9
  crcLookupTable(69).Hi = &H15
  crcLookupTable(70).Lo = &H32
  crcLookupTable(70).Hi = &H27
  crcLookupTable(71).Lo = &HBB
  crcLookupTable(71).Hi = &H36
  crcLookupTable(72).Lo = &H4C
  crcLookupTable(72).Hi = &HCE
  crcLookupTable(73).Lo = &HC5
  crcLookupTable(73).Hi = &HDF
  crcLookupTable(74).Lo = &H5E
  crcLookupTable(74).Hi = &HED
  crcLookupTable(75).Lo = &HD7
  crcLookupTable(75).Hi = &HFC
  crcLookupTable(76).Lo = &H68
  crcLookupTable(76).Hi = &H88
  crcLookupTable(77).Lo = &HE1
  crcLookupTable(77).Hi = &H99
  crcLookupTable(78).Lo = &H7A
  crcLookupTable(78).Hi = &HAB
  crcLookupTable(79).Lo = &HF3
  crcLookupTable(79).Hi = &HBA
  crcLookupTable(80).Lo = &H85
  crcLookupTable(80).Hi = &H52
  crcLookupTable(81).Lo = &HC
  crcLookupTable(81).Hi = &H43
  crcLookupTable(82).Lo = &H97
  crcLookupTable(82).Hi = &H71
  crcLookupTable(83).Lo = &H1E
  crcLookupTable(83).Hi = &H60
  crcLookupTable(84).Lo = &HA1
  crcLookupTable(84).Hi = &H14
  crcLookupTable(85).Lo = &H28
  crcLookupTable(85).Hi = &H5
  crcLookupTable(86).Lo = &HB3
  crcLookupTable(86).Hi = &H37
  crcLookupTable(87).Lo = &H3A
  crcLookupTable(87).Hi = &H26
  crcLookupTable(88).Lo = &HCD
  crcLookupTable(88).Hi = &HDE
  crcLookupTable(89).Lo = &H44
  crcLookupTable(89).Hi = &HCF
  crcLookupTable(90).Lo = &HDF
  crcLookupTable(90).Hi = &HFD
  crcLookupTable(91).Lo = &H56
  crcLookupTable(91).Hi = &HEC
  crcLookupTable(92).Lo = &HE9
  crcLookupTable(92).Hi = &H98
  crcLookupTable(93).Lo = &H60
  crcLookupTable(93).Hi = &H89
  crcLookupTable(94).Lo = &HFB
  crcLookupTable(94).Hi = &HBB
  crcLookupTable(95).Lo = &H72
  crcLookupTable(95).Hi = &HAA
  crcLookupTable(96).Lo = &H6
  crcLookupTable(96).Hi = &H63
  crcLookupTable(97).Lo = &H8F
  crcLookupTable(97).Hi = &H72
  crcLookupTable(98).Lo = &H14
  crcLookupTable(98).Hi = &H40
  crcLookupTable(99).Lo = &H9D
  crcLookupTable(99).Hi = &H51
  crcLookupTable(100).Lo = &H22
  crcLookupTable(100).Hi = &H25
  crcLookupTable(101).Lo = &HAB
  crcLookupTable(101).Hi = &H34
  crcLookupTable(102).Lo = &H30
  crcLookupTable(102).Hi = &H6
  crcLookupTable(103).Lo = &HB9
  crcLookupTable(103).Hi = &H17
  crcLookupTable(104).Lo = &H4E
  crcLookupTable(104).Hi = &HEF
  crcLookupTable(105).Lo = &HC7
  crcLookupTable(105).Hi = &HFE
  crcLookupTable(106).Lo = &H5C
  crcLookupTable(106).Hi = &HCC
  crcLookupTable(107).Lo = &HD5
  crcLookupTable(107).Hi = &HDD
  crcLookupTable(108).Lo = &H6A
  crcLookupTable(108).Hi = &HA9
  crcLookupTable(109).Lo = &HE3
  crcLookupTable(109).Hi = &HB8
  crcLookupTable(110).Lo = &H78
  crcLookupTable(110).Hi = &H8A
  crcLookupTable(111).Lo = &HF1
  crcLookupTable(111).Hi = &H9B
  crcLookupTable(112).Lo = &H87
  crcLookupTable(112).Hi = &H73
  crcLookupTable(113).Lo = &HE
  crcLookupTable(113).Hi = &H62
  crcLookupTable(114).Lo = &H95
  crcLookupTable(114).Hi = &H50
  crcLookupTable(115).Lo = &H1C
  crcLookupTable(115).Hi = &H41
  crcLookupTable(116).Lo = &HA3
  crcLookupTable(116).Hi = &H35
  crcLookupTable(117).Lo = &H2A
  crcLookupTable(117).Hi = &H24
  crcLookupTable(118).Lo = &HB1
  crcLookupTable(118).Hi = &H16
  crcLookupTable(119).Lo = &H38
  crcLookupTable(119).Hi = &H7
  crcLookupTable(120).Lo = &HCF
  crcLookupTable(120).Hi = &HFF
  crcLookupTable(121).Lo = &H46
  crcLookupTable(121).Hi = &HEE
  crcLookupTable(122).Lo = &HDD
  crcLookupTable(122).Hi = &HDC
  crcLookupTable(123).Lo = &H54
  crcLookupTable(123).Hi = &HCD
  crcLookupTable(124).Lo = &HEB
  crcLookupTable(124).Hi = &HB9
  crcLookupTable(125).Lo = &H62
  crcLookupTable(125).Hi = &HA8
  crcLookupTable(126).Lo = &HF9
  crcLookupTable(126).Hi = &H9A
  crcLookupTable(127).Lo = &H70
  crcLookupTable(127).Hi = &H8B
  crcLookupTable(128).Lo = &H8
  crcLookupTable(128).Hi = &H84
  crcLookupTable(129).Lo = &H81
  crcLookupTable(129).Hi = &H95
  crcLookupTable(130).Lo = &H1A
  crcLookupTable(130).Hi = &HA7
  crcLookupTable(131).Lo = &H93
  crcLookupTable(131).Hi = &HB6
  crcLookupTable(132).Lo = &H2C
  crcLookupTable(132).Hi = &HC2
  crcLookupTable(133).Lo = &HA5
  crcLookupTable(133).Hi = &HD3
  crcLookupTable(134).Lo = &H3E
  crcLookupTable(134).Hi = &HE1
  crcLookupTable(135).Lo = &HB7
  crcLookupTable(135).Hi = &HF0
  crcLookupTable(136).Lo = &H40
  crcLookupTable(136).Hi = &H8
  crcLookupTable(137).Lo = &HC9
  crcLookupTable(137).Hi = &H19
  crcLookupTable(138).Lo = &H52
  crcLookupTable(138).Hi = &H2B
  crcLookupTable(139).Lo = &HDB
  crcLookupTable(139).Hi = &H3A
  crcLookupTable(140).Lo = &H64
  crcLookupTable(140).Hi = &H4E
  crcLookupTable(141).Lo = &HED
  crcLookupTable(141).Hi = &H5F
  crcLookupTable(142).Lo = &H76
  crcLookupTable(142).Hi = &H6D
  crcLookupTable(143).Lo = &HFF
  crcLookupTable(143).Hi = &H7C
  crcLookupTable(144).Lo = &H89
  crcLookupTable(144).Hi = &H94
  crcLookupTable(145).Lo = &H0
  crcLookupTable(145).Hi = &H85
  crcLookupTable(146).Lo = &H9B
  crcLookupTable(146).Hi = &HB7
  crcLookupTable(147).Lo = &H12
  crcLookupTable(147).Hi = &HA6
  crcLookupTable(148).Lo = &HAD
  crcLookupTable(148).Hi = &HD2
  crcLookupTable(149).Lo = &H24
  crcLookupTable(149).Hi = &HC3
  crcLookupTable(150).Lo = &HBF
  crcLookupTable(150).Hi = &HF1
  crcLookupTable(151).Lo = &H36
  crcLookupTable(151).Hi = &HE0
  crcLookupTable(152).Lo = &HC1
  crcLookupTable(152).Hi = &H18
  crcLookupTable(153).Lo = &H48
  crcLookupTable(153).Hi = &H9
  crcLookupTable(154).Lo = &HD3
  crcLookupTable(154).Hi = &H3B
  crcLookupTable(155).Lo = &H5A
  crcLookupTable(155).Hi = &H2A
  crcLookupTable(156).Lo = &HE5
  crcLookupTable(156).Hi = &H5E
  crcLookupTable(157).Lo = &H6C
  crcLookupTable(157).Hi = &H4F
  crcLookupTable(158).Lo = &HF7
  crcLookupTable(158).Hi = &H7D
  crcLookupTable(159).Lo = &H7E
  crcLookupTable(159).Hi = &H6C
  crcLookupTable(160).Lo = &HA
  crcLookupTable(160).Hi = &HA5
  crcLookupTable(161).Lo = &H83
  crcLookupTable(161).Hi = &HB4
  crcLookupTable(162).Lo = &H18
  crcLookupTable(162).Hi = &H86
  crcLookupTable(163).Lo = &H91
  crcLookupTable(163).Hi = &H97
  crcLookupTable(164).Lo = &H2E
  crcLookupTable(164).Hi = &HE3
  crcLookupTable(165).Lo = &HA7
  crcLookupTable(165).Hi = &HF2
  crcLookupTable(166).Lo = &H3C
  crcLookupTable(166).Hi = &HC0
  crcLookupTable(167).Lo = &HB5
  crcLookupTable(167).Hi = &HD1
  crcLookupTable(168).Lo = &H42
  crcLookupTable(168).Hi = &H29
  crcLookupTable(169).Lo = &HCB
  crcLookupTable(169).Hi = &H38
  crcLookupTable(170).Lo = &H50
  crcLookupTable(170).Hi = &HA
  crcLookupTable(171).Lo = &HD9
  crcLookupTable(171).Hi = &H1B
  crcLookupTable(172).Lo = &H66
  crcLookupTable(172).Hi = &H6F
  crcLookupTable(173).Lo = &HEF
  crcLookupTable(173).Hi = &H7E
  crcLookupTable(174).Lo = &H74
  crcLookupTable(174).Hi = &H4C
  crcLookupTable(175).Lo = &HFD
  crcLookupTable(175).Hi = &H5D
  crcLookupTable(176).Lo = &H8B
  crcLookupTable(176).Hi = &HB5
  crcLookupTable(177).Lo = &H2
  crcLookupTable(177).Hi = &HA4
  crcLookupTable(178).Lo = &H99
  crcLookupTable(178).Hi = &H96
  crcLookupTable(179).Lo = &H10
  crcLookupTable(179).Hi = &H87
  crcLookupTable(180).Lo = &HAF
  crcLookupTable(180).Hi = &HF3
  crcLookupTable(181).Lo = &H26
  crcLookupTable(181).Hi = &HE2
  crcLookupTable(182).Lo = &HBD
  crcLookupTable(182).Hi = &HD0
  crcLookupTable(183).Lo = &H34
  crcLookupTable(183).Hi = &HC1
  crcLookupTable(184).Lo = &HC3
  crcLookupTable(184).Hi = &H39
  crcLookupTable(185).Lo = &H4A
  crcLookupTable(185).Hi = &H28
  crcLookupTable(186).Lo = &HD1
  crcLookupTable(186).Hi = &H1A
  crcLookupTable(187).Lo = &H58
  crcLookupTable(187).Hi = &HB
  crcLookupTable(188).Lo = &HE7
  crcLookupTable(188).Hi = &H7F
  crcLookupTable(189).Lo = &H6E
  crcLookupTable(189).Hi = &H6E
  crcLookupTable(190).Lo = &HF5
  crcLookupTable(190).Hi = &H5C
  crcLookupTable(191).Lo = &H7C
  crcLookupTable(191).Hi = &H4D
  crcLookupTable(192).Lo = &HC
  crcLookupTable(192).Hi = &HC6
  crcLookupTable(193).Lo = &H85
  crcLookupTable(193).Hi = &HD7
  crcLookupTable(194).Lo = &H1E
  crcLookupTable(194).Hi = &HE5
  crcLookupTable(195).Lo = &H97
  crcLookupTable(195).Hi = &HF4
  crcLookupTable(196).Lo = &H28
  crcLookupTable(196).Hi = &H80
  crcLookupTable(197).Lo = &HA1
  crcLookupTable(197).Hi = &H91
  crcLookupTable(198).Lo = &H3A
  crcLookupTable(198).Hi = &HA3
  crcLookupTable(199).Lo = &HB3
  crcLookupTable(199).Hi = &HB2
  crcLookupTable(200).Lo = &H44
  crcLookupTable(200).Hi = &H4A
  crcLookupTable(201).Lo = &HCD
  crcLookupTable(201).Hi = &H5B
  crcLookupTable(202).Lo = &H56
  crcLookupTable(202).Hi = &H69
  crcLookupTable(203).Lo = &HDF
  crcLookupTable(203).Hi = &H78
  crcLookupTable(204).Lo = &H60
  crcLookupTable(204).Hi = &HC
  crcLookupTable(205).Lo = &HE9
  crcLookupTable(205).Hi = &H1D
  crcLookupTable(206).Lo = &H72
  crcLookupTable(206).Hi = &H2F
  crcLookupTable(207).Lo = &HFB
  crcLookupTable(207).Hi = &H3E
  crcLookupTable(208).Lo = &H8D
  crcLookupTable(208).Hi = &HD6
  crcLookupTable(209).Lo = &H4
  crcLookupTable(209).Hi = &HC7
  crcLookupTable(210).Lo = &H9F
  crcLookupTable(210).Hi = &HF5
  crcLookupTable(211).Lo = &H16
  crcLookupTable(211).Hi = &HE4
  crcLookupTable(212).Lo = &HA9
  crcLookupTable(212).Hi = &H90
  crcLookupTable(213).Lo = &H20
  crcLookupTable(213).Hi = &H81
  crcLookupTable(214).Lo = &HBB
  crcLookupTable(214).Hi = &HB3
  crcLookupTable(215).Lo = &H32
  crcLookupTable(215).Hi = &HA2
  crcLookupTable(216).Lo = &HC5
  crcLookupTable(216).Hi = &H5A
  crcLookupTable(217).Lo = &H4C
  crcLookupTable(217).Hi = &H4B
  crcLookupTable(218).Lo = &HD7
  crcLookupTable(218).Hi = &H79
  crcLookupTable(219).Lo = &H5E
  crcLookupTable(219).Hi = &H68
  crcLookupTable(220).Lo = &HE1
  crcLookupTable(220).Hi = &H1C
  crcLookupTable(221).Lo = &H68
  crcLookupTable(221).Hi = &HD
  crcLookupTable(222).Lo = &HF3
  crcLookupTable(222).Hi = &H3F
  crcLookupTable(223).Lo = &H7A
  crcLookupTable(223).Hi = &H2E
  crcLookupTable(224).Lo = &HE
  crcLookupTable(224).Hi = &HE7
  crcLookupTable(225).Lo = &H87
  crcLookupTable(225).Hi = &HF6
  crcLookupTable(226).Lo = &H1C
  crcLookupTable(226).Hi = &HC4
  crcLookupTable(227).Lo = &H95
  crcLookupTable(227).Hi = &HD5
  crcLookupTable(228).Lo = &H2A
  crcLookupTable(228).Hi = &HA1
  crcLookupTable(229).Lo = &HA3
  crcLookupTable(229).Hi = &HB0
  crcLookupTable(230).Lo = &H38
  crcLookupTable(230).Hi = &H82
  crcLookupTable(231).Lo = &HB1
  crcLookupTable(231).Hi = &H93
  crcLookupTable(232).Lo = &H46
  crcLookupTable(232).Hi = &H6B
  crcLookupTable(233).Lo = &HCF
  crcLookupTable(233).Hi = &H7A
  crcLookupTable(234).Lo = &H54
  crcLookupTable(234).Hi = &H48
  crcLookupTable(235).Lo = &HDD
  crcLookupTable(235).Hi = &H59
  crcLookupTable(236).Lo = &H62
  crcLookupTable(236).Hi = &H2D
  crcLookupTable(237).Lo = &HEB
  crcLookupTable(237).Hi = &H3C
  crcLookupTable(238).Lo = &H70
  crcLookupTable(238).Hi = &HE
  crcLookupTable(239).Lo = &HF9
  crcLookupTable(239).Hi = &H1F
  crcLookupTable(240).Lo = &H8F
  crcLookupTable(240).Hi = &HF7
  crcLookupTable(241).Lo = &H6
  crcLookupTable(241).Hi = &HE6
  crcLookupTable(242).Lo = &H9D
  crcLookupTable(242).Hi = &HD4
  crcLookupTable(243).Lo = &H14
  crcLookupTable(243).Hi = &HC5
  crcLookupTable(244).Lo = &HAB
  crcLookupTable(244).Hi = &HB1
  crcLookupTable(245).Lo = &H22
  crcLookupTable(245).Hi = &HA0
  crcLookupTable(246).Lo = &HB9
  crcLookupTable(246).Hi = &H92
  crcLookupTable(247).Lo = &H30
  crcLookupTable(247).Hi = &H83
  crcLookupTable(248).Lo = &HC7
  crcLookupTable(248).Hi = &H7B
  crcLookupTable(249).Lo = &H4E
  crcLookupTable(249).Hi = &H6A
  crcLookupTable(250).Lo = &HD5
  crcLookupTable(250).Hi = &H58
  crcLookupTable(251).Lo = &H5C
  crcLookupTable(251).Hi = &H49
  crcLookupTable(252).Lo = &HE3
  crcLookupTable(252).Hi = &H3D
  crcLookupTable(253).Lo = &H6A
  crcLookupTable(253).Hi = &H2C
  crcLookupTable(254).Lo = &HF1
  crcLookupTable(254).Hi = &H1E
  crcLookupTable(255).Lo = &H78
  crcLookupTable(255).Hi = &HF
End Sub

'This function returns the CRC of the array at data for length positions
Private Function Get_Crc(ByRef data() As Byte, ByVal length As Integer) As WORD
  Dim Index As Integer
  Dim Table_Index As Integer
  Dim newCrc As WORD
  newCrc.Lo = &HFF
  newCrc.Hi = &HFF
  For Index = 0 To length - 1
    'exclusive-or the input byte with the low-order byte of the CRC register
    'to get an index into crcLookupTable
    Table_Index = newCrc.Lo Xor data(Index)
    'shift the CRC register eight bits to the right
    newCrc.Lo = newCrc.Hi
    newCrc.Hi = 0
    ' exclusive-or the CRC register with the contents of Table at Table_Index
    newCrc.Lo = newCrc.Lo Xor crcLookupTable(Table_Index).Lo
    newCrc.Hi = newCrc.Hi Xor crcLookupTable(Table_Index).Hi
  Next Index
  'Invert & return newCrc
  Get_Crc.Lo = newCrc.Lo Xor &HFF
  Get_Crc.Hi = newCrc.Hi Xor &HFF
End Function

Private Sub Send_Packet(ByRef Packet As PACKET_STRUCT)
  Dim Index As Integer
  'Need to put the whole packet into a linear array
  Dim linear_array(26) As Byte
  linear_array(0) = Packet.command
  linear_array(1) = Packet.data_length
  For Index = 0 To Packet.data_length - 1
    linear_array(Index + 2) = Packet.data(Index)
  Next Index
  Packet.crc = Get_Crc(linear_array, Packet.data_length + 2)
  'Might as well move the CRC into the linear array too
  linear_array(Packet.data_length + 2) = Packet.crc.Lo
  linear_array(Packet.data_length + 3) = Packet.crc.Hi
  'Now a simple loop can dump it out the port.
  For Index = 0 To Packet.data_length + 3
    Panel.Output = Chr(linear_array(Index))
  Next Index
End Sub




Public Sub SetBackLight(Intensity As Integer)

    Dim Packet As PACKET_STRUCT
    Dim i As Integer
    
    Initialize_CRC_Lookup_Table
            
    Packet.command = 14
    Packet.data_length = 1
    Packet.data(0) = Intensity
    
    For i = 0 To 15
        Packet.data(1 + i) = Asc(" ")
    Next
    
    Send_Packet Packet
        
End Sub


Public Sub SetConstrast(Intensity As Integer)

    Dim Packet As PACKET_STRUCT
    Dim i As Integer
    
    Initialize_CRC_Lookup_Table
        
    Packet.command = 13
    Packet.data_length = 1
    Packet.data(0) = Intensity
    For i = 0 To 15
        Packet.data(1 + i) = Asc(" ")
    Next
    
    Send_Packet Packet
        
End Sub


Private Sub SendLines(FirstLine As String, SecondLine As String)

  On Error GoTo ErrHandler
  
  Dim outgoing_packet As PACKET_STRUCT
  Dim Index As Integer
  
  Call Initialize_CRC_Lookup_Table
    
    If (Panel.PortOpen = True) Then
      
      'Build up the start of the packet
      outgoing_packet.command = 7
      outgoing_packet.data_length = 16
      outgoing_packet.data(0) = 0 'col
      outgoing_packet.data(1) = 0 'row
      'Default the packet's data to spaces
      For Index = 0 To 15
        outgoing_packet.data(2 + Index) = Asc(" ")
      Next Index
      'Load the packet's data from Line 1
      For Index = 0 To Len(FirstLine) - 1
        If Index < 16 Then
          outgoing_packet.data(Index) = Asc(Mid$(FirstLine, Index + 1, 1))
        End If
      Next Index
      'Calculate the CRC, and kick the whole thing out the port
      Call Send_Packet(outgoing_packet)
      
      
      'Build up the start of the packet
      outgoing_packet.command = 8
      'outgoing_packet.data_length = 22
      outgoing_packet.data_length = 16
      outgoing_packet.data(0) = 0 'col
      outgoing_packet.data(1) = 1 'row
      'Default the packet's data to spaces
      For Index = 0 To 15
        outgoing_packet.data(2 + Index) = Asc(" ")
      Next Index
      'Load the packet's data from Line 1
      For Index = 0 To Len(SecondLine) - 1
        If Index < 16 Then
          outgoing_packet.data(Index) = Asc(Mid$(SecondLine, Index + 1, 1))
        End If
      Next Index
      'Calculate the CRC, and kick the whole thing out the port
      Call Send_Packet(outgoing_packet)
      
    Else
      Err.Raise 102, "clsLCDPanel", "Port could not be opened."
    End If
  
Exit Sub
ErrHandler:
Err.Raise Err.Number, "clsLCDPanel", Err.Description
End Sub




Public Sub PacketAnalyzer(Packet)
    
    Dim SplitPacket() As String
    Dim i As Integer
    Dim MyPacket As String
    Dim temp As String
    
    MyPacket = ""
    For i = 0 To Len(Packet) - 1
        MyPacket = MyPacket & Asc(Mid$(Packet, i + 1, 1)) & " "
    Next
        
    SplitPacket = Split(MyPacket, " ")
        
    If SplitPacket(0) = "128" Then
    
        Debug.Print MyPacket & " --- " & UBound(SplitPacket)
            
        Select Case SplitPacket(2)
            
            Case "1"
            'Key Up Pressed
        
            Case "2"
            'Key Down Pressed
            
            Case "3"
            'Key Left Pressed
            
            Case "4"
            'Key Right Pressed
        
            Case "5"
            'Key Enter Pressed
        
            Case "6"
            'Key Cancel Pressed
    
            Case "7"
            'Key Up Released
            RaiseEvent ButtonReleased(UpButton)
            
            Case "8"
            'Key Down released
            RaiseEvent ButtonReleased(DownButton)
        
            Case "9"
            'Key left released
            RaiseEvent ButtonReleased(LeftButton)
            
            Case "10"
            'Key right released
            RaiseEvent ButtonReleased(RightButton)
            
            Case "11"
            'Key Enter released
            RaiseEvent ButtonReleased(EnterButton)
        
            Case "12"
            'Key Cancel released
            RaiseEvent ButtonReleased(CancelButton)
            
        End Select
        
    End If
    
End Sub

Private Sub Panel_OnComm()
    
    Dim ComPortData As String

    ComPortData = Panel.Input
    
    If ComPortData <> "" Then
        PacketAnalyzer ComPortData
    End If
    
    ComPortData = ""
    
End Sub

Private Sub PanelTimer_Timer()

    Dim FirstLine As String
    Dim SecondLine As String
                    
    If Len(PanelLine(0)) <= 16 Then
        ScrollDir1 = 2
    Else
        If ScrollPos1 > Len(PanelLine(0)) - 16 Then
            ScrollDir1 = 1
        ElseIf ScrollPos1 = 1 Then
            ScrollDir1 = 0
        End If
    End If
    
    If Len(PanelLine(1)) <= 16 Then
        ScrollDir2 = 2
    Else
        If ScrollPos2 > Len(PanelLine(1)) - 16 Then
            ScrollDir2 = 1
        ElseIf ScrollPos2 = 1 Then
            ScrollDir2 = 0
        End If
    End If
    
    
    If ScrollDir1 = 0 Then
        ScrollPos1 = ScrollPos1 + 1
    ElseIf ScrollDir1 = 1 Then
        If ScrollPos1 > 1 Then ScrollPos1 = ScrollPos1 - 1
    End If
    If ScrollDir2 = 0 Then
        ScrollPos2 = ScrollPos2 + 1
    ElseIf ScrollDir2 = 1 Then
        If ScrollPos2 > 1 Then ScrollPos2 = ScrollPos2 - 1
    End If
    
    
    FirstLine = Mid(PanelLine(0), ScrollPos1, 16)
    SecondLine = Mid(PanelLine(1), ScrollPos2, 16)
    
    SendLines FirstLine, SecondLine
    
End Sub
